/*
 * BootLoader.h
 *
 *  Created on: 2017419
 *      Author: admin
 */

#ifndef BOOTLOADER_BOOTLOADER_H_
#define BOOTLOADER_BOOTLOADER_H_
#include "DSP2833x_Device.h"
#include "DSP2833x_Examples.h"
#include "data.h"
#include "delay.h"
#include "stdint.h"
#include "CANA.h"
#include "Flash.h"
#define APP_START_ADDR  ((uint32_t)0x310000)
#define CAN_BL_APP      0xAAAAAAAA
#define CAN_BL_BOOT     0x55555555
//#define FW_TYPE         CAN_BL_BOOT
#define	DATA_PACK_SIZE	(1024+2)//2ֽCRC16У
#define DEVICE_ADDR 0x134//豸ַ
#define CAN_BOOT_GetAddrData() DEVICE_ADDR
#define CMD_WIDTH 4
#define ADDR_WIDTH 12
typedef struct _Device_INFO
{
	union
	{
		unsigned short int all;
		struct
		{
			unsigned short int Device_addr:	12;
			unsigned short int reserve:	4;
		}bits;//豸ַ
	}Device_addr;
	unsigned long int FW_TYPE;//̼
	unsigned long int FW_Version;//̼汾
}Device_INFO;
typedef struct _bootloader_data
{
	union
	{
		u32 all;
		struct
		{
			u16 cmd :CMD_WIDTH; //
			u16 addr :ADDR_WIDTH; //豸ַ
			u16 reserve :16; //λ
		} bit;
	} ExtId; //չ֡ID
	unsigned char IDE;   //֡,ΪCAN_ID_STD(׼֡),CAN_ID_EXT(չ֡)
	unsigned char DLC;  //ݳȣΪ08;
	u8 data[8];
} bootloader_data;
typedef struct _Boot_CMD_LIST
{
	//Bootloader
	unsigned char Erase;        //APP
	unsigned char Write;        //Զֽʽд
	unsigned char Check;        //ڵǷߣͬʱع̼Ϣ
	unsigned char Excute;       //ִй̼
	unsigned char WriteInfo;    //öֽдزдʼַ
	unsigned char SetBaudRate;  //ýڵ㲨
	//ڵ㷵״̬,ؼ
	unsigned char CmdFaild;     //ִʧ
	unsigned char CmdSuccess;   //ִгɹ


} Boot_CMD_LIST;
extern Boot_CMD_LIST cmd_list;
extern bootloader_data Bootloader_data;
extern Device_INFO DEVICE_INFO;
void __disable_irq(void);
void __enable_irq(void);
void __set_PRIMASK(u8 state);

unsigned short int CRCcalc16 (unsigned char *data,unsigned short int len);
void CAN_BOOT_JumpToApplication(uint32_t Addr);
void CAN_BOOT_ExecutiveCommand(CanRxMsg *pRxMessage);
#endif /* BOOTLOADER_BOOTLOADER_H_ */
