/**
  ******************************************************************************
  * @file    usb_device.h
  * $Author: wdluo $
  * $Revision: 447 $
  * $Date:: 2013-06-29 18:24:57 +0800 #$
  * @brief   USBòغͶ.
  ******************************************************************************
  * @attention
  *
  *<center><a href="http:\\www.usbxzy.com">http://www.usbxzy.com</a></center>
  *<center>All Rights Reserved</center></h3>
  * 
  ******************************************************************************
  */
#ifndef __USB_DEVICE_H_
#define __USB_DEVICE_H_

#include <stdint.h>
#ifndef OS_UNIX
#include <Windows.h>
#else
#include <unistd.h>
#ifndef WINAPI
#define WINAPI
#endif
#endif

typedef struct _DEVICE_INFO
{
    char    FirmwareName[32];   //ַ̼
    char    BuildDate[32];      //̼ʱַ
    int     HardwareVersion;    //Ӳ汾
    int     FirmwareVersion;    //̼汾
    int     SerialNumber[3];    //к
    int     Functions;          //ǰ߱Ĺ
}DEVICE_INFO,*PDEVICE_INFO;

#ifdef __cplusplus
extern "C"
{
#endif

/**
  * @brief  ʼUSB豸ɨ豸
  * @param  pDevNum ÿ豸豸Ŵ洢ַҪ豸ţԴNULL
  * @retval ɨ赽豸
  */
int  WINAPI USB_ScanDevice(int *pDevHandle);

/**
  * @brief  豸
  * @param  DevHandle 豸
  * @retval 豸״̬
  */
bool WINAPI USB_OpenDevice(int DevHandle);

/**
  * @brief  ر豸
  * @param  DevHandle 豸
  * @retval ر豸״̬
  */
bool WINAPI USB_CloseDevice(int DevHandle);

/**
  * @brief  ȡ豸Ϣ豸ƣ̼汾ţ豸ţ豸˵ַ
  * @param  DevHandle 豸
  * @param  pDevInfo 豸Ϣ洢ṹָ
  * @param  pFunctionStr 豸˵ַ
  * @retval ȡ豸Ϣ״̬
  */
bool WINAPI DEV_GetDeviceInfo(int DevHandle,PDEVICE_INFO pDevInfo,char *pFunctionStr);

/**
  * @brief  û
  * @param  DevHandle 豸
  * @retval ûݲ״̬
  */
bool WINAPI DEV_EraseUserData(int DevHandle);

/**
  * @brief  ûдûԶݣд֮ǰҪòݲ
  * @param  DevHandle 豸
  * @param  OffsetAddr дƫƵַʼַΪ0x00ûΪ0x10000ֽڣҲ64KBye
  * @param  pWriteData ûݻ׵ַ
  * @param  DataLen дֽ
  * @retval дûԶ״̬
  */
bool WINAPI DEV_WriteUserData(int DevHandle,int OffsetAddr,unsigned char *pWriteData,int DataLen);

/**
  * @brief  ûԶ
  * @param  DevHandle 豸
  * @param  OffsetAddr дƫƵַʼַΪ0x00ûΪ0x10000ֽڣҲ64KBye
  * @param  pReadData ûݻ׵ַ
  * @param  DataLen ֽ
  * @retval ûԶݵ״̬
  */
bool WINAPI DEV_ReadUserData(int DevHandle,int OffsetAddr,unsigned char *pReadData,int DataLen);

/**
  * @brief  ÿɱѹѹֵ
  * @param  DevHandle 豸
  * @param  PowerLevel ѹֵ0-1.8V1-3.3V
  * @retval ѹ״̬
  */
bool WINAPI DEV_SetPowerLevel(int DevHandle,char PowerLevel);

#ifdef __cplusplus
}
#endif

#endif

